/*
 * @Author: your name
 * @Date: 2019-10-30 22:01:59
 * @LastEditTime: 2019-10-30 22:51:48
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: \_Happydinosaur\assets\script\dinosaurGame.js.js
 */
// Learn cc.Class:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] https://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        player: cc.Node,
        spherePreb: cc.Prefab,
        clickNode: cc.Node,
        startBtn: cc.Button,
        mainPanel: cc.Node,
        startPanel: cc.Node,
        overPanel: cc.Node,
        restarBtn: cc.Button,
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad() {
        this.player.y = -(cc.winSize.height / 2) + 100;
        this.registerEvent();

        this.startGame = false;
        this.playerisDead = false /*玩家死亡状态  */
        this.startPanel.active = true;
        this.mainPanel.active = false;
        this.overPanel.active = false; /* 结束界面 */

    },

    /* 
     **点击开始按钮开始游戏
     */
    overGame() {
        this.startGame=false;
        this.overPanel.active = true;
        this.mainPanel.active = false;
         this.unschedule(this.addSphere);  /* 当游戏结束时停止生成sphere */
    },
    onStartBtn() {
        
        
        this.startPanel.active = false;
        this.mainPanel.active = true;
        this.overPanel.active = false;
        this.startGame = true;
        this.sphereArr = [];
        this.addSphere();
        this.schedule(this.addSphere, 0.5);
     

    },
    onRestartBtn() {
        this.startPanel.active = true;
        this.overPanel.active = false;
          this.unschedule(this.addSphere);
    },
    addSphere() {
        const sphereNode = cc.instantiate(this.spherePreb);
        const widthSize = cc.winSize.width - 200;
        const heightSize = cc.winSize.height;
        this.sphereArr.push(sphereNode);
        this.node.addChild(sphereNode);
        let posX = Math.random() * (widthSize - (-widthSize)) + (-widthSize);
         sphereNode.scale=Math.random()*((sphereNode.scale-0.5)+2);

        sphereNode.setPosition(cc.v2(posX, cc.winSize.height / 2 + 50));
        let moveToAction = cc.moveTo(1, cc.v2(posX, -(cc.winSize.height / 2) + 100));
        sphereNode.runAction(cc.sequence(moveToAction, cc.callFunc(() => {
            this.destroySphere(sphereNode);
        })));

    },
    destroySphere(sphere) {
        this.RemoveFromArr(this.sphereArr, sphere);
        sphere.destroy();
    },
    RemoveFromArr(arr, ele) {
        if (arr instanceof Array) {
            const index = arr.indexOf(ele);
            if (index > -1) {
                arr.splice(index, 1);
            }
        }
    },
    registerEvent() {
        this.clickNode.on(cc.Node.EventType.TOUCH_MOVE, this.playerMove, this); /*  */
    },
    playerMove(event) {
        const pos = event.getLocation();
        const prePos = event.getPreviousLocation();
        if (pos.x > prePos.x) {
            this.player.scaleX = -1;
        } else if (pos.x < prePos.x) {
            this.player.scaleX = 1;
        }
        this.player.x += pos.x - prePos.x;
        if (this.player.x > cc.winSize.width / 2 - 90)
            this.player.x = cc.winSize.width / 2 - 90;
        else if (this.player.x < -(cc.winSize.width / 2) + 90)
            this.player.x = -(cc.winSize.width / 20) + 90;
    },
    distance(sphereNode) {
        const dinasourPos = this.player.getPosition();
        const lineDistance = sphereNode.getPosition().sub(dinasourPos).mag();
        return lineDistance;
    },

    update(dt) {
        //  this.time-=dt;
        if (this.startGame) {


            for (const sphereItem of this.sphereArr) {
                if (this.distance(sphereItem) < 50) {
                    this.destroySphere(sphereItem);
                    this.playerisDead = true;
                    if (this.playerisDead === true) {
                        this.overGame();
                    }
                }
            }
        }
    },
});